﻿----------------------------------------------------------------------------------------------------------
------------------------------------------------MageGate------------------------------------------------
----------------------------------------------------------------------------------------------------------
-- Written by: Endar_Ren																				--
----------------------------------------------------------------------------------------------------------
----------------------------------------------Change History----------------------------------------------
----------------------------------------------------------------------------------------------------------
-- Version 1.1 Changes 8/25/2010																		--
-- *  Fixed use of addon when a target or a group member is casting a portal.							--
-- *  Corrected GateGroup function so that the Party channel is used outside of an instance.			--
-- *  Corrected spelling error:  "Dailing".																--
--======================================================================================================--							
-- Version 1.2 Changes 10/5/10																			--
-- *  Fixed the nothing happening in Party group type. (I think)										--
--======================================================================================================--
-- Version 1.3 Changes 10/13/2010																		--
-- *  Now usable in 4.0.1.																				--
--======================================================================================================--
-- Version 1.4 Changes 11/3/2010																		--
-- *  Add in Slash Command to turn the addon on and off. (Does not disable or enable the addon)			--
--======================================================================================================--
-- Version 1.4.1 Changes 11/18/2010																		--
-- *  Added Confirm Summons event and "Incoming traveller" message.  Need to test.	FAILED				--
-- *  Changed GateGroup to use number in the party to see if you are alone.	Need to test.  FAILED		--
-- *  Added version number field.																		--
--======================================================================================================--
-- Version 1.4.2  Changed 1/3/2011																		--
-- * Adding in sound effects.  Sounds given to me by Ricardo58.  Thank you.								--
--======================================================================================================--
-- Version 1.4.3 Changed 4/26/2011																		--
-- * TOC version number changed to 40100.																--
--======================================================================================================--
-- Version 2 Changed 7/1/2011																			--
-- * TOC version number changed to 40200.																--
-- * Ace3 Library implemented.																			--
-- * New Slash commands:  sfx & autosum.																--
-- * New Sound Effect for summon																		--
-- * Stargate Atlantis Dialing abort sound effect option added.											--
--======================================================================================================--
-- Version 2.1 Changed 3/5/2012																			--
-- * TOC AUTOSUMM saved variable renamed to AUTOSUMM2.													--
-- * AUTOSUMM2 is set to false by default now.															--
-- * Fixed get for abortfx to actually return ABORTSTY.													-- 
--======================================================================================================--
-- Version 3.0 Changed 5/2/2012																			--
-- * Changes made by Daimanu.																			--
-- * Portal identification method changed to deal with other languages.									--
-- * Chevron count up added, with customizable chevron number range.									--
-- *  French translation added.																			--
--======================================================================================================--
--  Version 3.1 Changed 5/17/2012																		--
--  *  Added option to disable the chevron count text.													--
--  *  Added sound effects of ring turning start and continue turning.									--
--======================================================================================================--
--	Version 6.0 Changed 6/12/2012																		--
--	*	Added play command to have sound effects play on request.										--
--	**		play command without value will list the names of all the sound effects						--
--	*	Changed SOUNDFX to an integer:  0 =off, 1=on, 2 = on & master (will be heard when WoW sound off --
--	*																					--
--	*	Added caster command to allow player to toogle whether portals casted by others will trigger fx.--
--	*	Hooks added for detection of using any portal.													--
--	*	SG exit sound fx added.																			--
--	*	Added Astrolabe library.																		--
--  *   Table of the IDs of all teleport spells															--
--  *   Portal Tracking added on minimap																--
--  *   UI Added.				
--  *   Added Star Gate:Atlantis Ring turning sound.
--  *   RINGTURNING value holds which ring turning to use.  "sg1" or "sga"
--  *   TELERING for basic teleport sfx on/off.
--  *   Chevron count fixed.														--
--======================================================================================================--
MageGate					= LibStub("AceAddon-3.0"):NewAddon("MageGate","AceConsole-3.0","AceComm-3.0", "AceEvent-3.0", "AceTimer-3.0","AceHook-3.0")
local L						= LibStub("AceLocale-3.0"):GetLocale("MageGate")
local settingMenu			= LibStub("AceConfigDialog-3.0")
local astrolabe				= DongleStub("TTAstrolabe-1.0")
local AceConfig				= LibStub("AceConfig-3.0")
local AceGUI				= LibStub("AceGUI-3.0")
local ringCount				= 0;
local tooltip				= CreateFrame("GameTooltip", "MGTooltip", UIParent, "GameTooltipTemplate")
tooltip.lines				= {}
local MG_VERSION			= 60001;
local channeling			= false;
local goingThroughPortal	= false
local openPortalList		= {} --Used to store opened portals for tracking.
--Field values



NeooptionTable = {
		name	= "MageGate",
		handler = MageGate,
		type	= 'group',
		args = {

				sfx =		{
									name = "Sound Effects",
									desc = L["SOUND_FX_DESC"],
									type = "execute",
									func = "SoundEffects"
							},
				settings =	{
									name = "MageGate Settings",
									desc = L["PRINT_SETTINGS"],
									type = "execute",
									func = "PrintSettings"
							},
				autosum  =  {
									name = "Auto Summon",
									desc = L["AUTO_SUMMON_DESC"],
									type = "execute",
									func = "AutoSummon"
							},
	--			abortfx  =  {
	--								name = "Abort Effect",
	--								desc = string.format(L["ABORT_FX_DESC"], "sg1", "sga"),
	--								type = "toggle",
	--								set	 = "ChangeAbortSFX",
	--								get  = function () return ABORTSTY end
	--						},
				marker  =   {
									name = "Marker Toggle",
									desc = L["MARKER_TOGGLE"],
									type = "toggle",
									set  = "MarkerToggle",
									get  = function () return MARKER end
							},
				chevcount = {
									name = "Print chevron count",
									desc = string.format(L["CHEV_COUNT_TOGGLE"]),
									type = "toggle",
									set  = "ChangeChevronCounter",
									get  = function () return CHEVRONCOUNTER end
							},
				wormexit =  {
									name = "Toggle Worm exit sfx",
									desc = string.format(L["WORM_EXIT_DESC"]),
									type = "toggle",
									set  = "toggleWormExit",
									get  = function () return WORMEXIT end
							},
				caster =	{
									name = "Toggle caster requirement",
									desc = L["CASTER_TOGGLE"],
									type = "toggle",
									set  = "ToogleJustYou",
									get  = function () return JUSTYOU end
							},
				play = 		{
									name = "Play a sound effect",
									desc = L["PLAY_DESC"],
									type = "input",
									set  = "PlayFX",
									get  = function () return nil end
							},
                show = 		{
									name = "Show control frame",
									desc = L["SHOW"] ,
									type = "execute",
									func = "ShowUI"
							},
				chevrons  = {
									name = "Number of chevrons",
									desc = L["CHEVRONS_COUNT_DESC"],
									type = "range",
									min  = 7,
									max  = 9,
									step = 1,
									set  = "SetChevronCount",
									get  = function () return CHEVRONCOUNT end
							}
				}
			}

LibStub("AceConfig-3.0"):RegisterOptionsTable("MageGate", NeooptionTable, {"mgate"})
protX, protY = nil,nil;


local teleportsID = {	556,	-- Astral Recall
						48020,	-- Demonic Circle
						120145,	--Ancient Dalaran
						53140,	-- Dalaran
						18960,	-- Moonglade
						3565,	--Darn
						32271,	--Exo
						3562,	--Iron
						32272,	--Silvermoon
						49358,	--Stonard
						3561,	--SW
						49359,	--Thera
						3566,	--Thunder Bluff
						88342,	--TBA
						88344,	--TBH
						3563,	-- Undercity
						3567,	--org
						33690,	--Shatt A
						35715,	--Shatt B
						36941,	-- Toshley
						23453,	--gadget
						71436,	--booty bay
						39937,	-- Slippers hearth
						8690,	--Hearth
						94719,	--Innkeeper
						48129,	--Recall scroll 1
						60320,	--Recall scroll 2
						60321,  --Recall scroll 3
						66238,	--Argent Tourney
						89157,	--Wrap unity SW
						89158,	--Wrap unity Org
						89157,	--shroud coop SW
						89158,	-- shroud coop org
						89157,	--Cloak coo sw
						89158,	--Cloak Coor Org
						89597,	--TB tabard All
						89598,	--TB tabard horde
						54406,	--Dalaran signet
						82674,	--Argus RANDOM
						23442,	--Everlook
						36890,	--Area 52
						22564,	--Stormpike recall
						22563	--Frostwolf
}
--92649  Battle coul
--87644 feast
local portalsID = {
	10059, -- StormWind
	11416, -- IronForge
	11417, -- Orgrimmar
	11418, -- Undercity
	11419, -- Darnassus
	11420, -- Thunder Bluff
	32266, -- Exodar
	32267, -- SilverMoon
	33691, -- Shattrath (Alliance)
	35717, -- Shattrath (Horde)
	49360, -- Theramore
	49361, -- Stonard
	53142, -- Dalaran
	88345, -- Tol Barad (Alliance)
	88346, -- Tol Barad (Horde)
	73324  -- Jania's Locket Dalaran
}
local wormholesID = {
	56273, -- Gadgetzan
	48933, -- Wormhole Northrend
}

local soundEffectTable = {}
function MageGate:ShowUI()
    MGSettingsFrame:Show()
end
--"Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Ring Starts Turning.ogg"

soundEffectTable["ring-start-1"]		= {fileName = "Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Ring Starts Turning.ogg"}
soundEffectTable["ring-turning-1"]		= {fileName ="Interface\\AddOns\\MageGate\\Sound Files\\SG Ring Turning without start.ogg"}
soundEffectTable["ring-turning-2"]		= {fileName ="Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Ring Turn.ogg"}
soundEffectTable["open"]				= {fileName ="Interface\\AddOns\\MageGate\\Sound Files\\Kawoosh 1.ogg"}
soundEffectTable["abort1"]				= {fileName ="Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Dial Abort.ogg"}
soundEffectTable["abort2"]				= {fileName ="Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Dial Abort.ogg"}
soundEffectTable["rings"]				= {fileName ="Interface\\AddOns\\MageGate\\Sound Files\\Rings 1.ogg"}

---------------------------------------------------- Portal Location Functions ----------------------------------------------------




function MageGate:IsNearPortal()

end
function MageGate:AddOpenPortal(casterName, spellID)
--Step 1:  Add it to the table.
--Step 2:  Create a timer, if the duration is not negative.

	openPortalList[UnitName(casterName).."-"..spellID] = { duration = 60, spent = time(), sfxTimer = 0, icon ={}}
	MageGate:ScheduleTimer("PortalExpire",60,UnitName(casterName).."-"..spellID)

	local m, f, x, y	= astrolabe:GetUnitPosition(UnitName(casterName), true)
	protX				= x;
	protY				= y
	
	--print("New Portal~"..UnitName(casterName).."~"..spellID.."~"..m.."~"..f.."~"..x.."~"..y)
	if MageGate:GateGroup () ~="SAY" then
		
		MageGate:SendCommMessage("MageGate","New Portal~"..UnitName(casterName).."~"..spellID.."~"..m.."~"..f.."~"..x.."~"..y,MageGate:GateGroup ())
		--print("New Portal~"..UnitName(casterName).."~"..spellID.."~"..m.."~"..f.."~"..x.."~"..y)
	end
	if MARKERS then
		MageGate:AddPortalToMinimap(UnitName(casterName), spellID,m, f, x, y)
	end
end
function MageGate:PortalExpire(id)
	
	
		astrolabe:RemoveIconFromMinimap(openPortalList[id].icon.minimap)--Unknown glitch
		openPortalList[id]=nil
	
	
end
function MageGate:RemovePortal()

end
function MageGate:MarkerToggle(info,val)
	MARKERS = MARKERS == false
	if MARKERS then
		MageGate:Mprint(L["MARKER_ON"])
	else
		MageGate:Mprint(L["MARKER_OFF"])
	end

end
function MageGate:AddPortalToMinimap(casterName, spellID,m, f, x, y)

	local minimap = CreateFrame("Button", nil, minimapParent)
	minimap:SetHeight(20)
	minimap:SetWidth(20)
	
	minimap.icon = minimap:CreateTexture("BACKGROUND")
	if spellID == 10059 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\SW")
	end
	if spellID == 11416 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\IF")
	end
	if spellID == 11419 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\Dar")
	end
	if spellID == 32266 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\Exa")
	end
	if spellID == 49360 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\Thera")
	end
	if spellID == 88345 or spellID == 88346 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\TBA")
	end
	if spellID == 35717 or spellID == 33691 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\Shatt")
	end
	if spellID == 11417 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\Org")
	end
	if spellID == 11418 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\UC")
	end
	if spellID == 11420 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\Thun")
	end
	if spellID == 49361 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\Sto")
	end
	if spellID == 32267 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\SM")
	end
	if spellID == 53142 then
		minimap.icon:SetTexture("Interface\\AddOns\\MageGate\\Images\\Dal")
	end

	
	minimap.special = spellID
	minimap.caster = casterName
	minimap:SetScript("OnEnter", markerOnEnter)
    minimap:SetScript("OnLeave", markerOnLeave)
	minimap:SetScript("OnClick", Minimap_OnClick)
	minimap.icon:SetPoint("CENTER", 0, 0)
	minimap.icon:SetHeight(12)
	minimap.icon:SetWidth(12)
	minimap.arrow = minimap:CreateTexture("BACKGROUND")
	minimap.arrow:SetTexture("Interface\\AddOns\\MageGate\\Images\\Chevron Arrow")
	minimap.arrow:SetPoint("CENTER", 0 ,0)
	minimap.arrow:SetHeight(40)
	minimap.arrow:SetWidth(40)
	minimap.arrow:Hide()
	
	point											= {}
	point.m											= m
    point.f											= f
    point.x											= x
    point.y											= y
    point.show_world								= true
    point.show_minimap								= true
	point.minimap									= minimap
	openPortalList[casterName.."-"..spellID].icon	= point
  --  point.minimap.callbacks = callbacks and callbacks.minimap

	astrolabe:PlaceIconOnMinimap(point.minimap, m, f, x, y)
end
function MageGate:PrintSettings(info,val)

	MageGate:Mprint(L["ADDON_SETTINGS"])
	
	-- Addon Active
	
	
	-- Autosummon
	if AUTOSUMM2 then
		MageGate:Mprint(L["AUTO_SUMMON_ON"])
	else
		MageGate:Mprint(L["AUTO_SUMMON_OFF"])
	end
	--Chevron Counter
	
	if CHEVCOUNTER == true then
		MageGate:Mprint(string.format(L["CHEV_COUNT_OFF"]))
	else
		MageGate:Mprint(string.format(L["CHEV_COUNT_ON"]))
	end
	
	--Chevron Number
	MageGate:Mprint(string.format(L["CHEVRON_COUNT_NUM"],CHEVRONCOUNT))
	
	-- Sound Effects
	
	if SOUNDFX == 0 then
		MageGate:Mprint(L["SOUND_FX_OFF"])
	end
	if SOUNDFX == 1 then
		MageGate:Mprint(L["SOUND_FX_ON"])
	end
	if SOUNDFX == 2 then
		MageGate:Mprint(L["SOUND_FX_MAST"])
	end
	-- Markers
	if MARKERS then
		MageGate:Mprint(L["MARKER_ON"])
	else
		MageGate:Mprint(L["MARKER_OFF"])
	end
	-- Caster has sound effect.
	if JUSTYOU then
		MageGate:Mprint(L["CASTER_YOU"])
	else
		MageGate:Mprint(L["CASTER_ALL"])
	end
	
	-- Exit Wormhole
	--WORMEXIT
	if WORMEXIT then
		MageGate:Mprint(L["WORM_EXIT_ON"])
	else
		MageGate:Mprint(L["WORM_EXIT_OFF"])
	end
	-- Abort Sfx Style
	MageGate:Mprint(string.format(L["ABORT_FX_CURR"], ABORTSTY))
	
	if TRAVELLER then
		MageGate:Mprint(L["TRAVELLER_ON"])
	else
		MageGate:Mprint(L["TRAVELLER_OFF"])
	end
	
end
function MageGate:PROTO()
    MageGate:Mprint("PROTO")
    
end
function Minimap_OnClick(self)
	--print("Casted by "..self.caster..".  Remainind time: "..tostring(60-(time()-openPortalList[self.caster.."-"..self.special].spent)))
	MageGate:Mprint(string.format(L["CASTER_REMAINING"],self.caster, 60-(time()-openPortalList[self.caster.."-"..self.special].spent)))
end
function markerOnEnter(self, motion)

	name = select(1,GetSpellInfo(self.special))
	local beg, last = string.find(name, L["PORTAL_SEP"]);
	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT")
	GameTooltip:SetText(string.sub(name, last+2))
	GameTooltip:Show()
end
function MageGate:markerOnLeave(selfl, motion)
	GameTooltip:Hide()
end


--- Indicates if the given spell is a portal spell
-- @param spellID
function isAPortal( spellID )
	for index, oneId in pairs( portalsID ) do
		if oneId == spellID then
			return true
		end
		if oneId > spellID then
			return false
		end
	end
	return false
end
function MageGate:isATeleport(spellID)
	--teleportsID
	for index, oneId in pairs( teleportsID ) do
		if oneId == spellID then
			return true
		end
	end
	return false
end
function MageGate:isAWormhole(spellID)
	for index, oneId in pairs( wormholesID ) do
		if oneId == spellID then
			return true
		end
	end
	return false
end
---------------------------------------------------- Timer Functions ----------------------------------------------------
local pTimer			= nil
local rTimer			= nil
local ringStartTimer	= nil
local nTicCount			= 1
--- Handler for a timer tic
function MageGate:ChevronNLocked()
	if channeling == false then
		self:CancelChevrons()
		return
	end
	if (nTicCount >= CHEVRONCOUNT) then
		self:CancelChevrons()
		return
	end
	
	SendChatMessage(string.format(L["CHEVRON_N_ENGAGED"], nTicCount), self:GateGroup())
	nTicCount = nTicCount + 1
end

function MageGate:RingLoop()
	if channeling == false then
		self:CancelRing()
		ringCount = 0
		return
	end
	if RINGTURNING == "sg1" then
		MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\SG Ring Turning without start.ogg")
	end
	if RINGTURNING == "sga" then
		MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Ring Turn.ogg")
	end
	ringCount = ringCount+1
	if ringCount == 6 then
		MageGate:CancelRing()
		ringCount = 0
	end
	--SG Ring Turning without start.ogg
end
function MageGate:WormholeSoundLoop(key)


end
function MageGate:CancelRing()
	if rTimer ~= nil then
		MageGate:CancelTimer(rTimer, false)
	else
		MageGate:CancelTimer(ringStartTimer, false)
	end
	rTimer = nil
	channeling = false
	ringStartTimer = nil
	ringCount = 0
end
--- Called when a portal is cancelled
function MageGate:CancelChevrons()
	MageGate:CancelTimer(pTimer, false)
	pTimer = nil
	channeling = false
	nTicCount = 1
end
---------------------------------------------------- Ace3 Functions ----------------------------------------------------
function MageGate:OnInitialize()
	if JUSTYOU == nil then
		JUSTYOU = true
	end
	if GATEON == nil then
		GATEON = true;
	end
	if SOUNDFX == nil then
		SOUNDFX = 1
	end
	if SOUNDFX == true then
		SOUNDFX =1
	end
	if SOUNDFX == false then
		SOUNDFX =0
	end
	if AUTOSUMM2 == nil then
		AUTOSUMM2 = false;
	end
	if ABORTSTY == nil then
		ABORTSTY = "sg1"
	end
	if CHEVRONCOUNT == nil then
		CHEVRONCOUNT = 7
	end
	if CHEVCOUNTER == nil then
		CHEVCOUNT = false;
	end
	if MARKERS == nil then
		MARKERS = true
	end
	if WORMEXIT == nil then
		WORMEXIT = true
	end
	if TRAVELLER == nil then
		TRAVELLER = true
	end
	if TELERING == nil then
		TELERING = false
	end
	
	if RINGTURNING == nil then
		RINGTURNING = "sg1"
	end
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_STOP")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED") 
	self:RegisterEvent("CONFIRM_SUMMON")
	self:RegisterEvent("CURSOR_UPDATE")	
	self:RegisterEvent("WORLD_MAP_UPDATE")
	self:RegisterEvent("ITEM_TEXT_BEGIN")
	self:RegisterEvent("UI_ERROR_MESSAGE") -- REMOVE
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:SecureHook("TurnOrActionStart","CCL")
	self:SecureHook("TurnOrActionStop","SSL")
	self:HookScript(GameTooltip,"OnUpdate","CIT")
	self:SecureHook("LFGTeleport","TeleHook")
	self:SecureHook("ConfirmSummon","SummSound")
	self:SecureHook("InteractUnit","curs")
	self:RegisterComm("MageGate")
    
    
end
function MageGate:OnEnable()


end

function MageGate:OnDisable()

end

function MageGate:OnCommReceived (prefix, mess, distr, sender)
	local yourName = UnitName("player")

	if sender ~= yourName then
		splitMes = MageGate:MessageBreaker(mess)
		len = MageGate:TableSize(splitMes)
		--MageGate:SendCommMessage("MageGate","New Portal~"..UnitName(casterName).."~"..spellID.."~"..m.."~"..f.."~"..x.."~"..y,MageGate:GateGroup ())
		if splitMes [1] == "New Portal" then
		
			caster = splitMes[2]
			spellID = tonumber(splitMes[3]) ---
			m = tonumber(splitMes[4])
			f = tonumber(splitMes[5])
			x = tonumber(splitMes[6])
			y = tonumber(splitMes[7])
			portalKey = caster.."-"..spellID
			if openPortalList[portalKey] == nil then
				openPortalList[portalKey] = {	duration = 60,
												spent = 0,
												sfxTimer = 0,
												icon ={}}
				MageGate:ScheduleTimer("PortalExpire",60,UnitName(caster).."-"..spellID)
				if MARKERS then
					MageGate:AddPortalToMinimap(caster, spellID,m, f, x, y )
				end
			end
		end
	end
end
function MageGate:curs (...)
	print("ER")
end
function MageGate:SummSound()
	area = GetSummonConfirmAreaName()
	if TRAVELLER then
		SendChatMessage(string.format(L["CONFIRM_SUMMON"]), self:GateGroup())
	end
	MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Rings 1.ogg")
end


---------------------------------------------------- Hook Functions ----------------------------------------------------

function MageGate:TeleHook()

	if TELERING then
		MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Rings 1.ogg")
	end
end
function MageGate:CIT()
--print(_G["GameTooltipTextLeft1"]:GetText())
	if _G["GameTooltipTextLeft1"]:GetText()~= nil then
		local beg, last = string.find(_G["GameTooltipTextLeft1"]:GetText(), L["Portal1"]);
		if strfind(strlower(_G["GameTooltipTextLeft1"]:GetText()),L["SOUL_PORTAL"]) ~= nil then
		
			if beg ~= nil then
				--print("It is a portalA")
				goingThroughPortal = true
			
			else
				goingThroughPortal = false
			end
		end
	end
end

--TurnOrActionStart
function MageGate:CCL()
if _G["GameTooltipTextLeft1"]:GetText()~= nil then
		local beg, last = string.find(_G["GameTooltipTextLeft1"]:GetText(), L["Portal1"]);
		if inRange ==false then
		end
	end
end
local xxx = 0
local yyy = 0
function MageGate:SSL()
	--GameTooltip:ClearLines()
	--GameTooltip:Show()
	if _G["GameTooltipTextLeft1"]:GetText()~= nil then
		local beg, last = string.find(_G["GameTooltipTextLeft1"]:GetText(), L["Portal1"]);
		if beg ~= nil then
			--print("stopped Is portal")
			if inRange then
			--	print("Stoop GOOD")
			else
				
			end
			goingThroughPortal = true
			xxx, yyy = GetPlayerMapPosition("player");
		else
	
			goingThroughPortal = false
		end
	end
	inRange = true
end
---------------------------------------------------- Event Handling ----------------------------------------------------
function MageGate:ITEM_TEXT_BEGIN()
	print("ITB")
end

function MageGate:CURSOR_UPDATE(...)

	--MageGate:ScheduleTimer("CIT", 1 )
	 
	--self:CCL()
	-- for i=1,GameTooltip:NumLines()do print(_G["GameTooltipTextLeft"..i]:GetText())end
	
--	for i = 1, select("#", GameTooltip:GetRegions()) do
   --     local region = select(i, GameTooltip:GetRegions())
   --     if region and region:GetObjectType() == "FontString" then
    --        local text = region:GetText() -- string or nil
	--		if text ~= nil then
			
	--		print ("TT "..text)
	--		end
    --    end
   -- end
end
function MageGate:UNIT_SPELLCAST_START(eveName, unitID, spell, rank, lineID, spellID)

	if MageGate:isAWormhole(spellID) then
		--print("Is wormhole")
	end
	
	local beg, last = string.find(spell, L["PORTAL_SEP"]);

	if isAPortal(spellID) and (unitID == "player") then
		MageGate:Anniversary()
		
		channeling = true;
		SendChatMessage(string.format(L["DIALING_START"], string.sub(spell, last+2)), self:GateGroup()); --Displays portal destination
	
		if RINGTURNING == "sg1" then
			MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Ring Starts Turning.ogg")
		end
		if RINGTURNING == "sga" then
			MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Ring Turn.ogg")
		end
		rTimer = MageGate:ScheduleRepeatingTimer("RingLoop", 2)
	
	if CHEVCOUNTER == true then  -- Only needs timer if chevron counter is on.
		local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spell)
		pTimer = MageGate:ScheduleRepeatingTimer("ChevronNLocked", castTime / (CHEVRONCOUNT*1000) )
	end
	-- ! Timer
	end
end
inRange = true
function MageGate:UI_ERROR_MESSAGE(info, mess)
	--print("ERR "..mess)
	inRange = false
end
function MageGate:UNIT_SPELLCAST_STOP(eveName, unitID, spell, rank, lineID, spellID)
--print ("pots")
end
function MageGate:UNIT_SPELLCAST_SUCCEEDED(eveName, unitID, spell, rank, lineID, spellID)
	--Doesn't cancel timer, it might have stoped itself
	if MageGate:isATeleport(spellID) and TELERING and UnitName(unitID) == UnitName("player") then
		--print("TELE")
		MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Rings 1.ogg")
	end
	if MageGate:isAWormhole(spellID) then
		--print("Is wormhole")
	end
	if isAPortal(spellID)  then
		if unitID ~= "player" and UnitName(unitID) == UnitName("player") then
		
		else
		
			MageGate:AddOpenPortal(unitID,spellID)
			
		end
		if  (unitID == "player") then
			channeling = false;
			
		end
		if JUSTYOU then
			
			if unitID == "player" then
				MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Kawoosh 1.ogg")
			end
		else	
			MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Kawoosh 1.ogg")	
		end
		if unitID == "player" then
			SendChatMessage(string.format(L["CHEVRON_N_LOCKED"], CHEVRONCOUNT), self:GateGroup());
		end
	end
end
function MageGate:UNIT_SPELLCAST_INTERRUPTED(eveName, unitID, spell, rank, lineID, spellID)
	if channeling == false then
	return
	end
	if isAPortal(spellID)  then
		if  (unitID == "player") then
			channeling = false;
			SendChatMessage(L["DIALING_ABORTED"], self:GateGroup());
			if CHEVCOUNTER == true then
				self:CancelChevrons();
				self:CancelRing();
			end
		end
		if JUSTYOU then
			if unitID == "player" then
				if string.find("sg1", ABORTSTY) ~= nil  then 
					MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Dial Abort.ogg")
				else
				--Atlantis Dial Abort
					MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Dial Abort.ogg")
						
				end
			end
		else
			if string.find("sg1", ABORTSTY) ~= nil  then 
				MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Dial Abort.ogg")
			else
				MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Dial Abort.ogg")
				--Atlantis Dial Abort			
			end
		end
	end
end
function MageGate:UNIT_SPELLCAST_FAILED_QUIET(eveName, unitID, spell, rank, lineID, spellID)
	if channeling == false then
		return
	end
	if isAPortal(spellID) and (unitID == "player") then
		channeling = false;
		SendChatMessage(L["DIALING_ABORTED"], self:GateGroup());
		if CHEVCOUNTER == true then
			self:CancelChevrons();
			self:CancelRing();
		end
		
		if ABORTSTY =="sg1"  then 
			MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Dial Abort.ogg")
		else
		--Atlantis Dial Abort			
			MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Atlantis Dial Abort.ogg")
		end
		
	end
end
function MageGate:PLAYER_ENTERING_WORLD()
	if goingThroughPortal and WORMEXIT then
		posX, posY = GetPlayerMapPosition("player");
		
		MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Exit-Enter 1.ogg")
		GameTooltip:ClearLines()
--	PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\Exit-Enter 1.ogg")
		goingThroughPortal = false;
		--print("EXIT")
		
			
	else
		goingThroughPortal = false;
		--print("FAILED")
	end
end
function MageGate:WORLD_MAP_UPDATE()
	if goingThroughPortal and WORMEXIT then
		posX, posY = GetPlayerMapPosition("player");
			if xxx == posX and posY == yyy then
			MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Exit-Enter 1.ogg")
			GameTooltip:ClearLines()
	--	PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\Exit-Enter 1.ogg")
			goingThroughPortal = false;
			end
			
		else
			goingThroughPortal = false;
		--print("FAILED")
	end
end
function MageGate:CONFIRM_SUMMON(eveName, ...)
	--Special thanks to Garshaw of Mok`Nathal for this idea.
	
	if AUTOSUMM2 == true then
		local chann = self.GateGroup();
		SendChatMessage(L["CONFIRM_SUMMON"], chann);
		if TELERING then
			MageGate:DoFx("Interface\\AddOns\\MageGate\\Sound Files\\Rings 1.ogg")
		end
		ConfirmSummon()
	end
end
---------------------------------------------------- Settings Methods ----------------------------------------------------
function MageGate:ToogleJustYou()
	JUSTYOU = JUSTYOU == false
	if JUSTYOU then
		MageGate:Mprint(L["CASTER_YOU"])
	else
		MageGate:Mprint(L["CASTER_ALL"])
	end
end
-- @param info, val  not really used.
function MageGate:toggleWormExit(info,val)
	WORMEXIT = WORMEXIT == false
	if WORMEXIT then
		MageGate:Mprint(L["WORM_EXIT_ON"])
	else
		MageGate:Mprint(L["WORM_EXIT_OFF"])
	end
	
end
-- @param info, val  not really used.
function MageGate:AutoSummon(info, val)
	AUTOSUMM2 = AUTOSUMM2 == false;
	if AUTOSUMM2 then
		MageGate:Mprint(L["AUTO_SUMMON_ON"])
	else
		MageGate:Mprint(L["AUTO_SUMMON_OFF"])
	end
end
function MageGate:TravellerToggle(info,val)
	TRAVELLER = TRAVELLER == false
	if TRAVELLER == true then
		MageGate:Mprint(L["TRAVELLER_OFF"])
	else
		MageGate:Mprint(L["TRAVELLER_ON"])
	end
end
function MageGate:ChangeChevronCounter(info, val)
	CHEVCOUNTER = CHEVCOUNTER == false
	if CHEVCOUNTER == true then
		CHEVCOUNTER = false
		MageGate:Mprint(string.format(L["CHEV_COUNT_OFF"]))
	else
		CHEVCOUNTER = true
		MageGate:Mprint(string.format(L["CHEV_COUNT_ON"]))
	end
end
function MageGate:SetChevronCount(info, val)
	local min, max = NeooptionTable.args.chevrons["min"], NeooptionTable.args.chevrons["max"] -- Better way to get params ?
	if (val >= min) and (val <= max) then
		CHEVRONCOUNT = val
	else
		MageGate:Mprint(string.format(L["CHEVRONS_COUNT_INVALID"], min, max))
	end
end
function MageGate:ChangeAbortSFX(info, val)
	if string.len(val) == 3 then
		if string.find("sg1",val) == nil then
			ABORTSTY = "sga"
		
		else
			ABORTSTY = "sg1"
		end
	else
		MageGate:Mprint(string.format(L["ABORT_FX_INVALID"], "sg1", "sga"))
	end

end
function MageGate:SoundEffects(info,val)
	if val == nil then
		if SOUNDFX ~= 2 then
			SOUNDFX= SOUNDFX+1
			if SOUNDFX == 1 then
				MageGate:Mprint(L["SOUND_FX_ON"])
			else
				MageGate:Mprint(L["SOUND_FX_MAST"])
			end
		else
			SOUNDFX = 0
			MageGate:Mprint(L["SOUND_FX_OFF"])
		end
	else
		SOUNDFX = SOUNDFX == false;
		if SOUNDFX then
			MageGate:Mprint(L["SOUND_FX_ON"])
		else
			MageGate:Mprint(L["SOUND_FX_OFF"])
		end
	end
end


---------------------------------------------------- Utility Functions ----------------------------------------------------
function MageGate:Anniversary()
	weekday, month, day, year = CalendarGetDate();
	if month == 8 and day == 10 then
		MageGate:Mprint(L["ANNIVERSARY"])
	end
end
function MageGate:Mprint(s)
	DEFAULT_CHAT_FRAME:AddMessage(("|cffffd800<|r|cffffd200%s|r|cffffd800>|r %s"):format(tostring("MageGate"), tostring(s..".")))
				--					 cffffd800
end

function MageGate:PlayFX(info, val)
		if soundEffectTable[val] ~= nil then
			PlaySoundFile(soundEffectTable[val].fileName, "Master")
		else
			MageGate:Mprint(L["SOUND_LIST"] )
			for key,val in pairs(soundEffectTable) do
				MageGate:Mprint(key)
			end
		end
end

--This function is used to determine which kind of group,
--if any, the player is in.  It returns the channel name
--needed to reach all the players in that group.
--The return value is a String.

function MageGate:GateGroup ()
	if GetNumPartyMembers()>0 then
		if (UnitInParty("player") ~= nil) then
			if (UnitInRaid("player") ~= nil) then
				return "RAID"
			end
			return "PARTY"
		end
	else
		if (UnitInRaid("player") ~= nil) then
				return "RAID"
		else
			if UnitInBattleground("player") ~= nil then
				return "BATTLEGROUND"
			else
			
			return "SAY"
			
			end
		end
	end
end

function MageGate:DoFx(fx)

	if SOUNDFX == 1 then
		PlaySoundFile(fx)
	end
	if SOUNDFX == 2 then
		PlaySoundFile(fx,"Master")
	end
end
function MageGate:TableSize(tab)
	count =0
	for key,val in pairs(tab) do
		count= count +1
	end
	return count
end
function MageGate:MessageBreaker(str)
	temp = str
	eke = {}
	count = 1
	while string.find(temp,"~")~= nil do
		eke[count]=string.sub(temp,0,string.find(temp,"~")-1)
		count = count+1
		temp = string.sub(temp,string.find(temp,"~")+1,string.len(temp))
	end
	eke[count] = temp
	return eke
end

----------------UI Function -----------------------


-- Chevron Count Functions
function MageGate:CheckChanged_ChevCount(self,button, down)
	CHEVCOUNT = self:GetChecked() 
end
function MageGate:OnShow_ChevCount(self)
--Add line to change text for localization.
	self:SetChecked(CHEVCOUNT)
end

-- Traveller Functions
function MageGate:CheckChanged_Traveller(self,button, down)
	TRAVELLER = self:GetChecked() 
end

